diff --git a/include/abg-comparison.h b/include/abg-comparison.h
index 1da8215ef19e..eab2850b1e32 100644
--- a/include/abg-comparison.h
+++ b/include/abg-comparison.h
@@ -13,7 +13,6 @@
 #include <ostream>
 #include <unordered_map>
 #include <unordered_set>
-#include "abg-cxx-compat.h"
 #include "abg-corpus.h"
 #include "abg-diff-utils.h"
 #include "abg-reporter.h"
diff --git a/include/abg-diff-utils.h b/include/abg-diff-utils.h
index 89eee495282d..0628950e2473 100644
--- a/include/abg-diff-utils.h
+++ b/include/abg-diff-utils.h
@@ -29,7 +29,6 @@
 #include <stdexcept>
 #include <string>
 #include <vector>
-#include "abg-cxx-compat.h"
 #include "abg-fwd.h"
 
 namespace abigail
diff --git a/include/abg-fwd.h b/include/abg-fwd.h
index 4d594afaccf6..bb839fe76315 100644
--- a/include/abg-fwd.h
+++ b/include/abg-fwd.h
@@ -19,7 +19,6 @@
 #include <unordered_map>
 #include <utility> // for std::rel_ops, at least.
 #include <vector>
-#include "abg-cxx-compat.h"
 #include "abg-interned-str.h"
 #include "abg-hash.h"
 
diff --git a/include/abg-ini.h b/include/abg-ini.h
index 665cdcd3d664..4ccb63bc4550 100644
--- a/include/abg-ini.h
+++ b/include/abg-ini.h
@@ -18,7 +18,6 @@
 #include <ostream>
 #include <string>
 #include <vector>
-#include "abg-cxx-compat.h"
 
 namespace abigail
 {
diff --git a/include/abg-interned-str.h b/include/abg-interned-str.h
index bd51350edd33..e25ea566d656 100644
--- a/include/abg-interned-str.h
+++ b/include/abg-interned-str.h
@@ -21,7 +21,6 @@
 #include <ostream>
 #include <string>
 #include <unordered_set>
-#include "abg-cxx-compat.h"
 
 
 namespace abigail
diff --git a/include/abg-ir.h b/include/abg-ir.h
index 06e03b5f14c9..ada947d7849b 100644
--- a/include/abg-ir.h
+++ b/include/abg-ir.h
@@ -21,7 +21,6 @@
 #include <functional>
 #include <set>
 #include <unordered_map>
-#include "abg-cxx-compat.h"
 #include "abg-fwd.h"
 #include "abg-hash.h"
 #include "abg-traverse.h"
diff --git a/include/abg-libxml-utils.h b/include/abg-libxml-utils.h
index 081bd8f2e908..69e940f6dffb 100644
--- a/include/abg-libxml-utils.h
+++ b/include/abg-libxml-utils.h
@@ -14,7 +14,6 @@
 #include <memory>
 
 #include "abg-sptr-utils.h"
-#include "abg-cxx-compat.h"
 
 namespace abigail
 {
diff --git a/include/abg-libzip-utils.h b/include/abg-libzip-utils.h
index 82378fa18f25..dc431d185a33 100644
--- a/include/abg-libzip-utils.h
+++ b/include/abg-libzip-utils.h
@@ -10,7 +10,6 @@
 
 #include <zip.h>
 #include <memory>
-#include "abg-cxx-compat.h"
 
 namespace abigail
 {
diff --git a/include/abg-regex.h b/include/abg-regex.h
index 477ebbb94a3d..9d8310fb9a8d 100644
--- a/include/abg-regex.h
+++ b/include/abg-regex.h
@@ -16,7 +16,6 @@
 #include <string>
 #include <vector>
 
-#include "abg-cxx-compat.h"
 #include "abg-sptr-utils.h"
 
 namespace abigail
diff --git a/include/abg-reporter.h b/include/abg-reporter.h
index 22d4d4258322..2374f6b37fed 100644
--- a/include/abg-reporter.h
+++ b/include/abg-reporter.h
@@ -16,7 +16,6 @@
 #include <memory>
 #include <ostream>
 #include <string>
-#include "abg-cxx-compat.h"
 
 namespace abigail
 {
diff --git a/include/abg-sptr-utils.h b/include/abg-sptr-utils.h
index 65def7d2f4f7..ef39703acdfe 100644
--- a/include/abg-sptr-utils.h
+++ b/include/abg-sptr-utils.h
@@ -13,7 +13,6 @@
 #include <regex.h>
 #include <memory>
 
-#include "abg-cxx-compat.h"
 
 namespace abigail
 {
diff --git a/include/abg-suppression.h b/include/abg-suppression.h
index 9c135607b42f..de2c60193887 100644
--- a/include/abg-suppression.h
+++ b/include/abg-suppression.h
@@ -10,7 +10,6 @@
 
 #include <unordered_set>
 
-#include "abg-cxx-compat.h"
 #include "abg-ini.h"
 #include "abg-comparison.h"
 
diff --git a/include/abg-tools-utils.h b/include/abg-tools-utils.h
index 14781a456301..053f8795e04b 100644
--- a/include/abg-tools-utils.h
+++ b/include/abg-tools-utils.h
@@ -14,7 +14,6 @@
 #include <ostream>
 #include <set>
 #include <string>
-#include "abg-cxx-compat.h"
 #include "abg-suppression.h"
 
 namespace abigail
diff --git a/include/abg-workers.h b/include/abg-workers.h
index 4cbff8308e42..5b5524471e1c 100644
--- a/include/abg-workers.h
+++ b/include/abg-workers.h
@@ -18,7 +18,6 @@
 
 #include <memory>
 #include <vector>
-#include "abg-cxx-compat.h"
 
 using std::shared_ptr;
 
diff --git a/src/abg-comp-filter.cc b/src/abg-comp-filter.cc
index a3320091c309..a0280d8eddf1 100644
--- a/src/abg-comp-filter.cc
+++ b/src/abg-comp-filter.cc
@@ -10,7 +10,6 @@
 /// This file contains definitions of diff objects filtering
 /// facilities.
 
-#include "abg-cxx-compat.h"
 #include "abg-internal.h"
 #include <memory>
 // <headers defining libabigail's API go under here>
diff --git a/src/abg-comparison-priv.h b/src/abg-comparison-priv.h
index 7b3587d8808d..8e2e59c6bcb6 100644
--- a/src/abg-comparison-priv.h
+++ b/src/abg-comparison-priv.h
@@ -16,7 +16,6 @@
 #ifndef __ABG_COMPARISON_PRIV_H__
 #define __ABG_COMPARISON_PRIV_H__
 
-#include "abg-cxx-compat.h"
 #include "abg-internal.h"
 // <headers defining libabigail's API go under here>
 #include <memory>
diff --git a/src/abg-corpus.cc b/src/abg-corpus.cc
index e2319d186259..2c37e253cf88 100644
--- a/src/abg-corpus.cc
+++ b/src/abg-corpus.cc
@@ -14,7 +14,6 @@
 #include <stdexcept>
 #include <unordered_map>
 
-#include "abg-cxx-compat.h"
 #include "abg-internal.h"
 
 // <headers defining libabigail's API go under here>
diff --git a/src/abg-dwarf-reader.cc b/src/abg-dwarf-reader.cc
index 2e137b211e71..2eee213f358a 100644
--- a/src/abg-dwarf-reader.cc
+++ b/src/abg-dwarf-reader.cc
@@ -33,7 +33,6 @@
 #include <unordered_map>
 #include <unordered_set>
 
-#include "abg-cxx-compat.h"
 #include "abg-ir-priv.h"
 #include "abg-suppression-priv.h"
 #include "abg-corpus-priv.h"
diff --git a/src/abg-hash.cc b/src/abg-hash.cc
index 7b54c177379a..ffa529e805cd 100644
--- a/src/abg-hash.cc
+++ b/src/abg-hash.cc
@@ -6,7 +6,6 @@
 /// @file
 
 #include <functional>
-#include "abg-cxx-compat.h"
 #include "abg-internal.h"
 // <headers defining libabigail's API go under here>
 ABG_BEGIN_EXPORT_DECLARATIONS
diff --git a/src/abg-ir.cc b/src/abg-ir.cc
index 5f931ee79509..1a4091b9370c 100644
--- a/src/abg-ir.cc
+++ b/src/abg-ir.cc
@@ -20,7 +20,6 @@
 #include <utility>
 #include <vector>
 
-#include "abg-cxx-compat.h"
 #include "abg-internal.h"
 // <headers defining libabigail's API go under here>
 ABG_BEGIN_EXPORT_DECLARATIONS
diff --git a/src/abg-reader.cc b/src/abg-reader.cc
index fb7326ed1b81..1fb0cf7d1074 100644
--- a/src/abg-reader.cc
+++ b/src/abg-reader.cc
@@ -22,7 +22,6 @@
 #include <sstream>
 #include <unordered_map>
 
-#include "abg-cxx-compat.h"
 #include "abg-suppression-priv.h"
 
 #include "abg-internal.h"
diff --git a/src/abg-suppression.cc b/src/abg-suppression.cc
index 4b955da7647b..d3343a814ef4 100644
--- a/src/abg-suppression.cc
+++ b/src/abg-suppression.cc
@@ -12,7 +12,6 @@
 
 #include <algorithm>
 
-#include "abg-cxx-compat.h"
 #include "abg-internal.h"
 #include <memory>
 
diff --git a/src/abg-tools-utils.cc b/src/abg-tools-utils.cc
index 7df3da5ffbfc..4d0191326dab 100644
--- a/src/abg-tools-utils.cc
+++ b/src/abg-tools-utils.cc
@@ -45,7 +45,6 @@
 
 #include "abg-dwarf-reader.h"
 #include "abg-internal.h"
-#include "abg-cxx-compat.h"
 #include "abg-regex.h"
 
 // <headers defining libabigail's API go under here>
diff --git a/src/abg-writer.cc b/src/abg-writer.cc
index 0953c8b3c7ee..d55bbbc166d5 100644
--- a/src/abg-writer.cc
+++ b/src/abg-writer.cc
@@ -22,7 +22,6 @@
 #include <unordered_map>
 #include <vector>
 
-#include "abg-cxx-compat.h"
 #include "abg-tools-utils.h"
 
 #include "abg-internal.h"
diff --git a/tests/test-diff-suppr.cc b/tests/test-diff-suppr.cc
index 0f7c448c7600..c7b73fd6d067 100644
--- a/tests/test-diff-suppr.cc
+++ b/tests/test-diff-suppr.cc
@@ -23,7 +23,6 @@
 #include <memory>
 #include <string>
 #include <unordered_set>
-#include "abg-cxx-compat.h"
 #include "abg-tools-utils.h"
 #include "abg-workers.h"
 #include "test-utils.h"
diff --git a/tests/test-read-write.cc b/tests/test-read-write.cc
index 1cddc0ea9220..ffca005251c0 100644
--- a/tests/test-read-write.cc
+++ b/tests/test-read-write.cc
@@ -14,7 +14,6 @@
 #include <memory>
 #include <string>
 #include <vector>
-#include "abg-cxx-compat.h"
 #include "abg-ir.h"
 #include "abg-reader.h"
 #include "abg-writer.h"
diff --git a/tools/abicompat.cc b/tools/abicompat.cc
index 2007a391932f..f9b019fbd0c6 100644
--- a/tools/abicompat.cc
+++ b/tools/abicompat.cc
@@ -34,7 +34,6 @@
 #include <iostream>
 #include <memory>
 #include <string>
-#include "abg-cxx-compat.h"
 #include "abg-config.h"
 #include "abg-tools-utils.h"
 #include "abg-corpus.h"
diff --git a/tools/abidw.cc b/tools/abidw.cc
index 9e8251f63cc5..bf4de28324d0 100644
--- a/tools/abidw.cc
+++ b/tools/abidw.cc
@@ -21,7 +21,6 @@
 #include <memory>
 #include <string>
 #include <vector>
-#include "abg-cxx-compat.h"
 #include "abg-config.h"
 #include "abg-tools-utils.h"
 #include "abg-corpus.h"
diff --git a/tools/abilint.cc b/tools/abilint.cc
index 63d0d6b8a1f9..aaf500f72818 100644
--- a/tools/abilint.cc
+++ b/tools/abilint.cc
@@ -21,7 +21,6 @@
 #include <memory>
 #include <string>
 #include <vector>
-#include "abg-cxx-compat.h"
 #include "abg-config.h"
 #include "abg-tools-utils.h"
 #include "abg-ir.h"
diff --git a/tools/abipkgdiff.cc b/tools/abipkgdiff.cc
index 3decc9205729..783a8d9a5359 100644
--- a/tools/abipkgdiff.cc
+++ b/tools/abipkgdiff.cc
@@ -82,7 +82,6 @@
 #include <unordered_set>
 #include <vector>
 
-#include "abg-cxx-compat.h"
 #include "abg-workers.h"
 #include "abg-config.h"
 #include "abg-tools-utils.h"